#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>        /* Per i socket AF_UNIX */
#include <unistd.h>
#include <stdlib.h>
#include "common.h"

/* Legge la ricetta inviata dal server */
int readRecipe (int fd);

int main (int argc, char *argv[]) {
  int clientFd, serverLen, recNum, result;
  struct sockaddr_un serverUNIXAddress;
  struct sockaddr* serverSockAddrPtr;

  serverSockAddrPtr = (struct sockaddr*) &serverUNIXAddress;
  serverLen = sizeof (serverUNIXAddress);

  if (argc != 2) {
    printf("cook: Uso scorretto. Sintassi: cook <recNum>\n");
    exit(EXIT_FAILURE);
  }

  /* Crea un socket UNIX, bidirezionale, protocollo di default */
  clientFd = socket (AF_UNIX, SOCK_STREAM, DEFAULT_PROTOCOL);
  serverUNIXAddress.sun_family = AF_UNIX; /* Dominio del server */
  strcpy (serverUNIXAddress.sun_path, "recipe"); /* Nome del server */

  do { /* Stabilisce la connessione con il server */
     result = connect (clientFd, serverSockAddrPtr, serverLen);
     if (result == -1) sleep (1); /* Se fallisce, riprova dopo breve attesa */
  }   while (result == -1);

  recNum = atoi(argv[1]);
  write(clientFd, &recNum, sizeof(int)); /* Richiede la ricetta recNum */
  readRecipe (clientFd); /* Legge e stampa la ricetta */
  close (clientFd); /* Chiude il socket */
  exit (EXIT_SUCCESS);
}

/* Legge la ricetta inviata dal server */
int readRecipe (int fd) {
  char str[MAX_LINE];        /* per tenere righe di testo */
  int readSome = 0;
  
  printf("\n");

  while (readLine (fd, '\0', str)) { /* Legge fino alla fine dell'input,
				        righe terminate da NULL */
    readSome = 1;
    printf ("%s\n", str);   /* e stampa quanto letto */
  }
  
  printf("\n");
  return readSome;
}
